#
# spec file for package apache2-mod_cband
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define mod_name mod_cband
#
Name:           apache2-mod_cband
Version:        0.9.7.5
Release:        11.9
#
Summary:        Apache 2 Bandwidth Quota and Throttling
#
License:        GPL-2.0 and BSD-4-Clause
Group:          Productivity/Networking/Web/Servers
#
Url:            http://cband.linux.pl
Source:         http://cband.linux.pl/download/mod-cband-%{version}.tgz
Patch0:         mod-cband-0.9.7.3_install.patch
Patch1:         mod-cband-0.9.7.5-pointer.diff
Patch2:         cband-ap24.patch
# didn't try to upstream as project seems not to be maintained anymore
Patch3:         mod-cband-uninitialized-memory.patch
BuildRequires:  apache2-devel
BuildRequires:  apache-rpm-macros
Requires:       %{apache_mmn}
Requires:       %{apache_suse_maintenance_mmn}
Requires:       apache2
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
mod_cband is an Apache 2 module provided to solve the problem of limiting
users' and virtualhosts' bandwidth usage. The current versions can set
virtualhosts' and users' bandwidth quotas, maximal download speed (like in
mod_bandwidth), requests-per-second speed and the maximal number of simultanous
IP connections (like in mod_limitipconn)

I advise using mod_cband by hosting companies, which would like to limit data
transfer for their users, such as "10 Gb of traffic per month". There already
exists the mod_curb module, which can limit data transfers, but it doesn't work
with virtualhosts and Apache 2, so I wrote my own module fully compatible with
Apache 2 API and supporting per-user and per-virtualhost bandwidth limiting

 Authors:
----------
    * Lukasz Dembinski <dembol@cband.linux.pl>
    * Sergey V. Beduev <shaman@interdon.net>
    * Kyle Poulter <kyle@unixowns.us>
    * J. Kendzorra <kenzo@kenzo.homelinux.org>
    * Adam Dawidowski <drake@oomkill.net>
    * Arvind Srinivasan <arvind@madtux.org>

%prep
%setup -q -n mod-cband-%{version}
%patch0
%patch1 -p1
%patch2 -p1
%patch3

%build
%configure --with-apxs=%{apache_apxs}
make %{?_smp_mflags}

%install
install -Dd -m 0755 %{buildroot}%{apache_libexecdir}
make DESTDIR=%{buildroot} install %{?_smp_mflags} APXS_INST_FLAGS="-S LIBEXECDIR=%{buildroot}%{apache_libexecdir}"

%check
#set +x
#%%apache_test_module_load -m cband:actions:alias:authn_file:authz_groupfile:authz_user:autoindex:cgi:env:include:log_config:mime:negotiation:setenvif:ssl:socache_shmcb:userdir:reqtimeout:authn_core:ext_filter
#set -x

%files
%defattr(-,root,root)
%{apache_libexecdir}/%{mod_name}.so
%doc libpatricia.copyright LICENSE Changes AUTHORS INSTALL
%doc conf/ doc/*

%changelog
* Thu Sep  3 2015 pgajdos@suse.com
- uninitialized *.shmem_id leads to segfault
  + mod-cband-uninitialized-memory.patch
* Mon Aug 31 2015 pgajdos@suse.com
- test module with %%apache_test_module
* Thu Jul 16 2015 pgajdos@suse.com
- Requries: %%{apache_suse_maintenance_mmn}
  This will pull this module to the update (in released distribution)
  when apache maintainer thinks it is good (due api/abi changes).
* Fri Oct 31 2014 pgajdos@suse.com
- call spec-cleaner
- use apache rpm macros
* Fri Aug  2 2013 crrodriguez@opensuse.org
- cband-ap24.patch : fix build with apache 2.4
* Thu Mar  3 2011 draht@suse.de
- if() statements with pointer arithmetics corrected.
* Tue Jun 10 2008 poeml@suse.de
- build service supports the debuginfo flag in metadata now; remove
  debug_package macro from the specfile therefore.
* Fri Apr 13 2007 poeml@suse.de
- require apache_mmn
* Fri Apr 13 2007 mrueckert@suse.de
- update to 0.9.7.5: see Changes file
* Mon May 29 2006 mrueckert@suse.de
- update to 0.9.7.4: see Changes file
* Wed Apr 26 2006 mrueckert@suse.de
- Update to 0.9.7.3: Too many changes to mention them all here.
  Please see: /usr/share/doc/packages/apache2-mod_cband/Changes.
- added mod-cband-0.9.7.3_install.patch:
  This patch adds APXS_INST_FLAGS. we can overwrite them as param
  to make install to avoid automatic enabling and to install
  into a buildroot.
* Sat Sep 17 2005 mrueckert@suse.de
- Initial package of version 0.9.2
